--File created by Miro Lua v2.5
--Pong v0.5 Single Player Fast Game Source

red = Color.new(0,255,255,255)

math.randomseed(os.time())
oldpad = Controls.read()

--Game Vars.
Player = {x = 2,y = 50,speed = (FspeedS/4),score = 0,img = Image.load("Image/player.png"),name}
AI = {x = 462,y = 40,speed = (FspeedS/5),score = 0,img = Image.load("Image/AI.png")}
Ball = {x = 240, y = math.random(90,120),xspeed = -(FspeedS / 5),yspeed = (FspeedS / 4),img = Image.load("Image/ball.png")}


--Other Vars. and Tables
Psp = {w = 480,h = 272}
gamestate = "paused"
white = Color.new(255,255,255,255)
whoScored = nil
paddlespot = math.random(10,(AI.img:height() - 10))
--Get Music....
Mp3me.load(System.currentDirectory().."/Music/BG.mp3")
--Get Nickname...

Player.name = System.nickName()

if Player.name == "" then
	Player.name = "Player"
end
if Player.name == "                           " then
	Player.name = "Player"
end

--Functions
--DrawImages() pastes objects on screen
function DrawImages()

	--Draws BarScope
	for i = 1, 480 do
		xline =  i
		Image.drawLine(xline, (Mp3me.visL(i) + 25), xline, 272, red)
	end

	Image.blit(Player.x,Player.y,Player.img)
	Image.blit(AI.x,AI.y,AI.img)
	Image.blit(Ball.x,Ball.y,Ball.img)
	if Mp3me.eos() == true then
		Mp3me.load(System.currentDirectory().."/Music/BG.mp3")
		Mp3me.play()
	end
end

--Paused() shows a paused screen
function Paused()
	pad = Controls.read()
	screen.print(60,145,"Press X to resume play OR O to quit to main menu.",0.6,white,0)
	if pad:cross() and oldpad:cross() ~= pad:cross() then
		gamestate = "playing"
	elseif pad:circle() and oldpad:circle() ~= pad:circle() then
		Mp3me.stop()
		dofile("script.lua")
	end
end

--BallMovement() checks to see if ball hits the top or bottom of the screen and reflects apon it
function BallMovement()
	
	if Ball.y <= 0 then
		Ball.yspeed = (FspeedS / 4)
	end

	if Ball.y + Ball.img:height() > Psp.h then
		Ball.yspeed = -(FspeedS / 4)
	end

	Ball.x = Ball.x + Ball.xspeed
	Ball.y = Ball.y + Ball.yspeed
end

--PlayerMovement() moves the player image according to button presses
function PlayerMovement()
	pad = Controls.read()

	if pad:up() and Player.y > 0 then
		Player.y = Player.y - Player.speed
	end

	if pad:down() and Player.y + Player.img:height() < Psp.h then
		Player.y = Player.y + Player.speed
	end

	if pad:start() then
		gamestate = "paused"
	end
end

--PlayerDeflet() checks to see where the ball hits and deflects it acordingly
--function PlayerDeflect()
--	local playerX = Player.x
--	local playerL = Player.img:length() + Player.x
--	local playerM = (playerX + playerL) / 2
--	if Ball.y == playerX then Ball.yspeed = Ball.yspeed + 3 end
--	if Ball.y > playerM and Ball.y < playerX then Ball.yspeed = Ball.yspeed + 1 end
--	if Ball.y == playerM then Ball.yspeed = -(Ball.xspeed) end
--	if Ball.y < playerM and Ball.y > playerL then Ball.yspeed = Ball.yspeed - 1 end
--	if Ball.y == playerL then Ball.yspeed = Ball.yspeed - 3 end
--end
--
--AIDeflect() is the same aas above, but reversed
--function AIDeflect()
--	local AIX = AI.x
--	local AIL = AI.img:length() + AI.x
--	local AIM = (AIX + AIL) / 2
--	if Ball.y == AIX then Ball.yspeed = Ball.yspeed + 3 end
--	if Ball.y > AIM and Ball.y < AIX then Ball.yspeed = Ball.yspeed + 1 end
--	if Ball.y == AIM then Ball.yspeed = -(Ball.xspeed) end
--	if Ball.y < AIM and Ball.y > AIL then Ball.yspeed = Ball.yspeed - 1 end
--	if Ball.y == AIL then Ball.yspeed = Ball.yspeed - 3 end
--end

--ChkCollision() checks to see if ball hit either paddle and refelcts it in the opposite direction
function ChkCollision(obj1,obj2)
	if (obj1.x + obj1.img:width() > obj2.x) and (obj1.x < obj2.x + obj2.img:width()) and (obj1.y + obj1.img:height() > obj2.y) and (obj1.y < obj2.y + obj2.img:height()) then
		if (obj1.y > obj2.y) and (obj1.y < (obj2.y + obj2.img:height() / 2)) then
			obj1.yspeed = (FspeedS / 4)
			FspeedS = FspeedS + 0.5
		else
			obj1.yspeed = -(FspeedS / 4)
			FspeedS = FspeedS + 0.5
		end

		if obj2 == Player then
			obj1.xspeed = (FspeedS / 5)
			FspeedS = FspeedS + 0.5
		else
			obj1.xspeed = -(FspeedS / 5)
			FspeedS = FspeedS + 0.5
		end
	end
end

--ChkScore check the place of the ball and add score the the player that go the point
function ChkScore()
	if Ball.x < 0 - Ball.img:width() then
		gamestate = "scored"
		AI.score = AI.score + 1
		whoScored = "AI"
		Ball.x = 240
		Ball.y = math.random(80,160)
		Ball.xspeed = (FspeedS / 5)
	end

	if Ball.x > Psp.w then
		gamestate = "scored"
		Player.score = Player.score + 1
		whoScored = "Player"
		Ball.x = 240
		Ball.y = math.random(80,160)
		Ball.xspeed = -(FspeedS / 5)
	end
end

--DrawScore() well....draws the score to the screen.....deededee
function DrawScore()
	screen.print(10,15,Player.name,0.6,white,0)
	screen.print(10,25,Player.score,0.6,white,0)
	screen.print(400,15,"AI",0.6,white,0)
	screen.print(400,25,AI.score,0.6,white,0)
end

--HasScored() prints the info of the scores on to screen when someone scores
function HasScored()
	pad = Controls.read()
	if Player.score == 10 then
		screen.print(160,135,"Player wins the game!!",0.6,white,0)
	elseif AI.score == 10 then
		screen.print(160,135,"Computer wins the game.....>:(",0.6,white,0)
	else
		screen.print(160,135,whoScored .. " scored 1 point",0.6,white,0)
	end
	screen.print(60,145,"Press X to play again or O to go back to the main menu.",0.6,white,0)
	if pad:cross() then
		if Player.score == 10 or AI.score == 10 then
			Player.score = 0
			AI.score = 0
		end
	gamestate = "playing"
	elseif pad:circle() then
		state = "menu"
	end
end

--AI()
function cpuAI()
	if Ball.xspeed > 0 and Ball.x > 200 then
		if (AI.y + paddlespot < Ball.y) and (AI.y < (Psp.h - AI.img:height())) then
			AI.y = AI.y + AI.speed
			paddlespot = math.random(1,AI.img:height())
		end

		if AI.y + paddlespot > Ball.y and AI.y > 0 then
			AI.y = AI.y -AI.speed
			paddlespot = math.random(1,AI.img:height())
		end
	end
end

Mp3me.play()
state = "game"
gamestate = "paused"
--<Main Game Loop>
while true do
	if state == "game" then
		screen.startDraw()
		screen.clear(0)

		if Mp3me.eos == "true" then
			Mp3me.play()
		end

		DrawImages()
		DrawScore()

		--If game is paused then use Paused()
		if gamestate == "paused" then
			Paused()
			oldpad = pad
		end

		--If game has got a score then show info about scoring
		if gamestate == "scored" then
			HasScored()
		end

	
		--If game is playing play
		if gamestate == "playing" then
			if FspeedS > 75 then FspeedS = 75 end
			PlayerMovement()
			BallMovement()
			cpuAI()
			ChkCollision(Ball,Player)
			ChkCollision(Ball,AI)
			ChkScore()
		end
		screen.endDraw()
		screen.waitVblankStart()
		screen.flipscreen()
	elseif state == "menu" then
		Mp3me.stop()
		dofile("script.lua")
	end
end
