--File created by Miro Lua v2.4
--Pong v0.5 Single-Player Game source

red = Color.new(255,0,0,255)
Scope = Color.new(68, 68, 255,255)

math.randomseed(os.time())
oldpad = Controls.read()

--Game Vars.
Player = {x = 2,y = 50,speed = 8,score = 0,img = Image.load("Image/player.png"),name = "Player1"}
P2 = {x = 462,y = 40,speed = 8,score = 0,img = Image.load("Image/ai.png"),name = "Player2"}
Ball = {x = 240, y = math.random(90,120),xspeed = -(speedS / 5),yspeed = (speedS / 4),img = Image.load("Image/ball.png")}

--Other Vars. and Tables
Psp = {w = 480,h = 272}
gamestate = "paused"
white = Color.new(255,255,255,255)
whoScored = nil

--Get Music....
Mp3me.load(System.currentDirectory().."/Music/BG.mp3")


--Functions
--DrawImages() pastes objects on screen
function DrawImages()

	--Draws BarScope
	for i = 0, 480 do
		Image.drawLine(i, (Mp3me.visL(i) + 25), i, 272, Scope)
	end

	Image.blit(Player.x,Player.y,Player.img)
	Image.blit(P2.x,P2.y,P2.img)
	Image.blit(Ball.x,Ball.y,Ball.img)
	if Mp3me.eos() == true then
		Mp3me.load(System.currentDirectory().."/Music/BG.mp3")
		Mp3me.play()
	end
end

--Paused() shows a paused screen
function Paused()
	pad = Controls.read()
	screen.print(60,145,"Press X to resume play OR O to quit to main menu.",0.6,white,0)
	if pad:cross() and oldpad:cross() ~= pad:cross() then
		gamestate = "playing"
	elseif pad:circle() and oldpad:circle() ~= pad:circle() then
		Mp3me.stop()
		dofile("script.lua")
	end
end

--BallMovement() checks to see if ball hits the top or bottom of the screen and reflects apon it
function BallMovement()
	
	if Ball.y <= 0 then
		Ball.yspeed = (speedS / 4)
	end

	if Ball.y + Ball.img:height() > Psp.h then
		Ball.yspeed = -(speedS / 4)
	end

	Ball.x = Ball.x + Ball.xspeed
	Ball.y = Ball.y + Ball.yspeed
end

--PlayerMovement() moves the player image according to button presses
function PlayerMovement()
	pad = Controls.read()

	if pad:up() and Player.y > 0 then
		Player.y = Player.y - Player.speed
	end

	if pad:down() and Player.y + Player.img:height() < Psp.h then
		Player.y = Player.y + Player.speed
	end

	if pad:start() then
		gamestate = "paused"
	end
end

--PlayerDeflet() checks to see where the ball hits and deflects it acordingly
--function PlayerDeflect()
--	local playerX = Player.x
--	local playerL = Player.img:height() + Player.x
--	local playerM = (playerX + playerL) / 2
--	if Ball.y == playerX then Ball.yspeed = Ball.yspeed + 3 end
--	if Ball.y > playerM and Ball.y < playerX then Ball.yspeed = Ball.yspeed + 1 end
--	if Ball.y == playerM then Ball.yspeed = -(Ball.yspeed) end
--	if Ball.y < playerM and Ball.y > playerL then Ball.yspeed = Ball.yspeed - 1 end
--	if Ball.y == playerL then Ball.yspeed = Ball.yspeed - 3 end
--end
--
--P2Deflect() is the same as above, but reversed
--function P2Deflect()
--	local P2X = P2.x
--	local P2L = P2.img:height() + P2.x
--	local P2M = (P2X + P2L) / 2
--	if Ball.y == P2X then Ball.yspeed = Ball.yspeed + 3 end
--	if Ball.y > P2M and Ball.y < P2X then Ball.yspeed = Ball.yspeed + 1 end
--	if Ball.y == P2M then Ball.yspeed = -(Ball.yspeed) end
--	if Ball.y < P2M and Ball.y > P2L then Ball.yspeed = Ball.yspeed - 1 end
--	if Ball.y == P2L then Ball.yspeed = Ball.yspeed - 3 end
--end

--ChkCollision() checks to see if ball hit either paddle and refelcts it in the opposite direction
function ChkCollision(obj1,obj2)
	if (obj1.x + obj1.img:width() > obj2.x) and (obj1.x < obj2.x + obj2.img:width()) and (obj1.y + obj1.img:height() > obj2.y) and (obj1.y < obj2.y + obj2.img:height()) then
		if (obj1.y > obj2.y) and (obj1.y < (obj2.y + obj2.img:height() / 2)) then
			obj1.yspeed = (speedS / 4)
		else
			obj1.yspeed = -(speedS / 4)
		end

		if obj2 == Player then
			obj1.xspeed = (speedS / 5)
		else
			obj1.xspeed = -(speedS / 5)
		end
	end
end

--ChkScore check the place of the ball and add score the the player that go the point
function ChkScore()
	if Ball.x < 0 - Ball.img:width() then
		gamestate = "scored"
		P2.score = P2.score + 1
		whoScored = "P2"
		Ball.x = 240
		Ball.y = math.random(10,260)
		Ball.xspeed = (speedS / 5)
	end

	if Ball.x > Psp.w then
		gamestate = "scored"
		Player.score = Player.score + 1
		whoScored = "Player"
		Ball.x = 240
		Ball.y = math.random(10,260)
		Ball.xspeed = -(speedS / 5)
	end
end

--DrawScore() well....draws the score to the screen.....deededee
function DrawScore()
	screen.print(10,15,Player.name,0.6,white,0)
	screen.print(10,25,Player.score,0.6,white,0)
	screen.print(400,15,P2.name,0.6,white,0)
	screen.print(400,25,P2.score,0.6,white,0)
end

--HasScored() prints the info of the scores on to screen when someone scores
function HasScored()
	pad = Controls.read()
	if Player.score == 10 then
		screen.print(160,135,"Player1 wins the game!!",0.6,white,0)
	elseif P2.score == 10 then
		screen.print(160,135,"Player2 wins the game!!",0.6,white,0)
	else
		screen.print(160,135,whoScored .. " scored 1 point",0.6,white,0)
	end
	screen.print(60,145,"Press X to play again or O to go back to the main menu.",0.6,white,0)
	if pad:cross() then
		if Player.score == 10 or P2.score == 10 then
			Player.score = 0
			P2.score = 0
		end
	gamestate = "playing"
	elseif pad:circle() then
		state = "menu"
	end
end

--P2Movement()
function P2Movement()
	pad = Controls.read()

	if pad:triangle() and P2.y > 0 then
		P2.y = P2.y - P2.speed
	end

	if pad:cross() and P2.y + P2.img:height() < Psp.h then
		P2.y = P2.y + P2.speed
	end
end

Mp3me.play()
state = "game"
gamestate = "paused"
--<Main Game Loop>
while true do
	if state == "game" then
		screen.startDraw()
		screen.clear(0)

		if Mp3me.eos == "true" then
			Mp3me.play()
		end

		DrawImages()
		DrawScore()

		--If game is paused then use Paused()
		if gamestate == "paused" then
			Paused()
			oldpad = pad
		end

		--If game has got a score then show info about scoring
		if gamestate == "scored" then
			HasScored()
		end


		--If game is playing play
		if gamestate == "playing" then
			PlayerMovement()
			P2Movement()
			BallMovement()
			ChkCollision(Ball,Player)
			ChkCollision(Ball,P2)
			ChkScore()
		end
		screen.endDraw()
		screen.waitVblankStart()
		screen.flipscreen()
	elseif state == "menu" then
		Mp3me.stop()
		dofile("script.lua")
	end
end
