--File created by Miro Lua v2.4
--Pong v0.4 Multi-Player Same PSP Game source

math.randomseed(os.time())
oldpad = Controls.read()

--Game Vars.
P1 = {x = 2,y = 50,speed = 5,score = 0,img = Image.load("Image/Player.png")}
P2 = {x = 462,y = 40,speed = 5,score = 0,img = Image.load("Image/AI.png")}
Ball = {x = 240, y = math.random(60,180),xspeed = -(speedM/5),yspeed = (speedM/4),img = Image.load("Image/ball.png")}

--Other Vars. and Tables
Psp = {w = 480,h = 272}
gamestate = "paused"
white = Color.new(255,255,255,255)
whoScored = nil

--Functions
--DrawImages() pastes objects on screen
function DrawImages()
	Image.blit(P1.x,P1.y,P1.img,true)
	Image.blit(P2.x,P2.y,P2.img,true)
	Image.blit(Ball.x,Ball.y,Ball.img,true)
end

--Paused() shows a paused screen
function Paused()
	pad = Controls.read()
	screen.print(160,145,"Press Start to resume play",0.6,white,1)
	if pad:start() and oldpad:start() ~= pad:start() then
		gamestate = "playing"
	end
end

--BallMovement() checks to see if ball hits the top or bottom of the screen and reflects apon it
function BallMovement()
	if Ball.y <= 0 then
		Ball.yspeed = (speedM/4)
	end

	if Ball.y + Ball.img:height() > Psp.h then	
		Ball.yspeed = -(speedM/4) 
	end

	Ball.x = Ball.x + Ball.xspeed
	Ball.y = Ball.y + Ball.yspeed
end

--P1Movement() moves the P1 image according to button presses
function P1Movement()
	pad = Controls.read()

	if pad:up() and P1.y > 0 then
		P1.y = P1.y - P1.speed
	end

	if pad:down() and P1.y + P1.img:height() < Psp.h then
		P1.y = P1.y + P1.speed
	end

	if pad:start() and oldpad:start() ~= pad:start() then
		gamestate = "paused"
	end
end

--ChkCollision() checks to see if ball hit either paddle and refelcts it in the opposite direction
function ChkCollision(obj1,obj2)
	if (obj1.x + obj1.img:width() > obj2.x) and (obj1.x < obj2.x + obj2.img:width()) and (obj1.y + obj1.img:height() > obj2.y) and (obj1.y < obj2.y + obj2.img:height()) then
		if (obj1.y > obj2.y) and (obj1.y < (obj2.y + obj2.img:height() / 2)) then	
			obj1.yspeed = (speedM/4) 
		else 
			obj1.yspeed = -(speedM/4)
		end

		if obj2 == P1 then
			obj1.xspeed = (speedM/5)
		else
			obj1.xspeed = -(speedM/5)
		end
	end
end

--ChkScore check the place of the ball and add score the the P1 that go the point
function ChkScore()
	if Ball.x < 0 - Ball.img:width() then
		gamestate = "scored"
		P2.score = P2.score + 1
		whoScored = "P2"
		Ball.x = 240
		Ball.y = math.random(80,160)
		Ball.xspeed = (speedM/5)
	end

	if Ball.x > Psp.w then
		gamestate = "scored"
		P1.score = P1.score + 1
		whoScored = "P1"
		Ball.x = 240
		Ball.y = math.random(80,160)
		Ball.xspeed = -(speedM/5)
	end
end

--DrawScore() well....draws the score to the screen.....deededee
function DrawScore()
	screen.print(10,5,"P1:",0.6,white,1)
	screen.print(10,15,P1.score,0.6,white,1)
	screen.print(400,5,"P2:",0.6,white,1)
	screen.print(400,15,P2.score,0.6,white,1)
end

--HasScored() prints the info of the scores on to screen when someone scores
function HasScored()
	pad = Controls.read()
	if P1.score == 10 then
		screen.print(160,135,"P1 wins the game!!",0.6,white,1)
	elseif P2.score == 10 then
		screen.print(160,135,"P2 won the game!!",0.6,white,1)
	else
		screen.print(160,135,whoScored .. " scored 1 point",0.6,white,1)
	end
	screen.print(60,145,"Press X to play again or O to go back to the main menu.",0.6,white,1)
	if pad:cross() then
		if P1.score == 10 or P2.score == 10 then
			P1.score = 0
			P2.score = 0
		end
	gamestate = "playing"
	elseif pad:circle() then
		state = "menu"
	end
end

--P2Movement()
function P2Movement()
	pad = Controls.read()

	if pad:triangle() and P2.y > 0 then
		P2.y = P2.y - P2.speed
	end

	if pad:cross() and P2.y + P2.img:height() < Psp.h then
		P2.y = P2.y + P2.speed
	end
end

--<Main Game Loop>
while true do
	if state == "game" then
		screen.startDraw()
		screen.clear(0)

		DrawImages()
		DrawScore()

		--If game is paused then use Paused()
		if gamestate == "paused" then
			Paused()
			oldpad = pad
		end

		--If game has got a score then show info about scoring
		if gamestate == "scored" then
			HasScored()
		end

	
		--If game is playing play
		if gamestate == "playing" then
			P1Movement()
			P2Movement()
			BallMovement()
			ChkCollision(Ball,P1)
			ChkCollision(Ball,P2)
			ChkScore()
		end
		
		oldpad = pad
		screen.endDraw()
		screen.waitVblankStart()
		screen.flipscreen()
	elseif state == "menu" then
		dofile("script.lua")
	end
end




