--File created by Miro Lua v2.4
--Pong v0.5 Wallball Game source

red = Color.new(255,0,0,255)
Scope = Color.new(68, 68, 255,255)
green = Color.new(0,255,0,255)

math.randomseed(os.time())
oldpad = Controls.read()
OriginalspeedS = speedS

--Game Vars.
Player = {x = 2,y = 50,speed = (speedS/4),score = 0,img = Image.load("Image/player.png"),name = "Player"}
AI = {x = 460,y = 0,img = Image.createEmpty(25,272)}
Ball = {x = 240, y = math.random(90,120),xspeed = -(speedS / 5),yspeed = (speedS / 4),img = Image.load("Image/ball.png")}

--Other Vars. and Tables
Psp = {w = 480,h = 272}
gamestate = "paused"
white = Color.new(255,255,255,255)
numbHits = 0
Image.clear(AI.img,red)

--Get Music....
Mp3me.load(System.currentDirectory().."/Music/BG.mp3")
--Get Nickname...

Player.name = System.nickName()

if Player.name == "" then
	Player.name = "Player"
end
if Player.name == "                           " then
	Player.name = "Player"
end

--Functions
--DrawImages() pastes objects on screen
function DrawImages()

	--Draws BarScope
	for i = 0, 480 do
		Image.drawLine(i, (Mp3me.visL(i) + 25), i, 272, Scope)
	end

	Image.blit(Player.x,Player.y,Player.img)
	Image.blit(AI.x,AI.y,AI.img)
	Image.blit(Ball.x,Ball.y,Ball.img)
	if Mp3me.eos() == true then
		Mp3me.load(System.currentDirectory().."/Music/BG.mp3")
		Mp3me.play()
	end
end

--Paused() shows a paused screen
function Paused()
	pad = Controls.read()
	screen.print(60,145,"Press X to resume play OR O to quit to main menu.",0.6,white,0)
	if pad:cross() and oldpad:cross() ~= pad:cross() then
		gamestate = "playing"
	elseif pad:circle() and oldpad:circle() ~= pad:circle() then
		speedS = OriginalspeedS
		Mp3me.stop()
		dofile("script.lua")
	end
end

--BallMovement() checks to see if ball hits the top or bottom of the screen and reflects apon it
function BallMovement()
	
	if Ball.y <= 0 then
		speedS = speedS + 0.1
		Ball.yspeed = (speedS / 4)
	end

	if Ball.y + Ball.img:height() > Psp.h then
		speedS = speedS + 0.1
		Ball.yspeed = -(speedS / 4)
	end

	Ball.x = Ball.x + Ball.xspeed
	Ball.y = Ball.y + Ball.yspeed
end

--PlayerMovement() moves the player image according to button presses
function PlayerMovement()
	pad = Controls.read()

	if pad:up() and Player.y > 0 then
		Player.y = Player.y - Player.speed
	end

	if pad:down() and Player.y + Player.img:height() < Psp.h then
		Player.y = Player.y + Player.speed
	end

	if pad:start() then
		gamestate = "paused"
	end
end

--PlayerDeflet() checks to see where the ball hits and deflects it acordingly
--function PlayerDeflect()
--	local playerX = Player.x
--	local playerL = Player.img:height() + Player.x
--	local playerM = (playerX + playerL) / 2
--	if Ball.y == playerX then Ball.yspeed = Ball.yspeed + 3 end
--	if Ball.y > playerM and Ball.y < playerX then Ball.yspeed = Ball.yspeed + 1 end
--	if Ball.y == playerM then Ball.yspeed = -(Ball.yspeed) end
--	if Ball.y < playerM and Ball.y > playerL then Ball.yspeed = Ball.yspeed - 1 end
--	if Ball.y == playerL then Ball.yspeed = Ball.yspeed - 3 end
--end
--
--AIDeflect() is the same as above, but reversed
--function AIDeflect()
--	local AIX = AI.x
--	local AIL = AI.img:height() + AI.x
--	local AIM = (AIX + AIL) / 2
--	if Ball.y == AIX then Ball.yspeed = Ball.yspeed + 3 end
--	if Ball.y > AIM and Ball.y < AIX then Ball.yspeed = Ball.yspeed + 1 end
--	if Ball.y == AIM then Ball.yspeed = -(Ball.yspeed) end
--	if Ball.y < AIM and Ball.y > AIL then Ball.yspeed = Ball.yspeed - 1 end
--	if Ball.y == AIL then Ball.yspeed = Ball.yspeed - 3 end
--end

--ChkCollision() checks to see if ball hit either paddle and refelcts it in the opposite direction
function ChkCollision(obj1,obj2)
	if (obj1.x + obj1.img:width() > obj2.x) and (obj1.x < obj2.x + obj2.img:width()) and (obj1.y + obj1.img:height() > obj2.y) and (obj1.y < obj2.y + obj2.img:height()) then
		if (obj1.y > obj2.y) and (obj1.y < (obj2.y + obj2.img:height() / 2)) then
		speedS = speedS + 0.1
			obj1.yspeed = (speedS / 4)
		else
		speedS = speedS + 0.1
			obj1.yspeed = -(speedS / 4)
		end

		if obj2 == Player then
		speedS = speedS + 0.1
			obj1.xspeed = (speedS / 5)
		else
		speedS = speedS + 0.1
			obj1.xspeed = -(speedS / 5)
			numbHits = numbHits + 1
		end
	end
end

--ChkScore check the place of the ball and add score the the player that go the point
function ChkEnd()
	if Ball.x <=0 then
		gameover = true
	else
		gameover = false
	end
end

--DrawScore() well....draws the score to the screen.....deededee
function DrawScore()
	Player.score = numbHits
	screen.print(10,15,Player.name,0.6,white,0)
	screen.print(10,25,Player.score,0.6,white,0)
end

Mp3me.play()
state = "game"
gamestate = "paused"
--<Main Game Loop>
while not gameover do
	if state == "game" then
		screen.startDraw()
		screen.clear(0)

		if Mp3me.eos == "true" then
			Mp3me.play()
		end

		DrawImages()
		DrawScore()

		--If game is paused then use Paused()
		if gamestate == "paused" then
			Paused()
			oldpad = pad
		end

		--If game is playing play
		if gamestate == "playing" then
			PlayerMovement()
			BallMovement()
			ChkCollision(Ball,Player)
			ChkCollision(Ball,AI)
			ChkEnd()
		end
		screen.endDraw()
		screen.waitVblankStart()
		screen.flipscreen()
	elseif state == "menu" then
		Mp3me.stop()
		dofile("script.lua")
	end
end

System.message("You hit the wall " .. numbHits .. " times.",0)
speedS = OriginalspeedS
dofile("script.lua")
